package org.bdware.doip;

import org.bdware.doip.codec.doipMessage.DoipMessage;
import org.bdware.doip.endpoint.client.ClientConfig;
import org.bdware.doip.endpoint.client.DoipClientImpl;
import org.bdware.doip.endpoint.client.DoipMessageCallback;
import org.junit.Test;

import java.util.concurrent.atomic.AtomicInteger;


public class DoipClientTest {
    @Test
    public void doipClientRetrieveTest(){
        final AtomicInteger total = new AtomicInteger(0);
        final AtomicInteger correct = new AtomicInteger(0);
        int totalCount = 1;
        for (int i = 0; i < totalCount; i++) {
            final DoipClientImpl doipClient = new DoipClientImpl();
            doipClient.connect(ClientConfig.fromUrl("tcp://127.0.0.1:8080"));
            doipClient.retrieve("aibd/do.e626924a-3b1c-492f-9a41-59179bfe0361", null, true, new DoipMessageCallback() {
                @Override
                public void onResult(DoipMessage msg) {
                    String str = new String(msg.body.encodedData);
                    System.out.println("Result is " + str);
                    //LOGGER.info("Retrieved:" + str
                    //+ " respCode:" + msg.header.parameters.response);
                    total.incrementAndGet();
                    if (str.contains("aaa"))
                        correct.incrementAndGet();
                    if (doipClient != null) doipClient.close();
                }
            });
        }
        int circle = 0;
        for (; total.get() < totalCount; ) {
            if (++circle % 100 == 0) {
                try {
                    Thread.sleep(10);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        }
    }

    @Test
    public void doipClientHelloTest(){
        final AtomicInteger total = new AtomicInteger(0);
        final AtomicInteger correct = new AtomicInteger(0);
        int totalCount = 1;
        for (int i = 0; i < totalCount; i++) {
            final DoipClientImpl doipClient = new DoipClientImpl();
            doipClient.connect(ClientConfig.fromUrl("tcp://127.0.0.1:8080"));
            doipClient.hello("aibd/do.e626924a-3b1c-492f-9a41-59179bfe0361", new DoipMessageCallback() {
                @Override
                public void onResult(DoipMessage msg) {
                    String str = new String(msg.body.encodedData);
                    System.out.println("Result is " + str);
                    //LOGGER.info("Retrieved:" + str
                    //+ " respCode:" + msg.header.parameters.response);
                    total.incrementAndGet();
                    if (str.contains("aaa"))
                        correct.incrementAndGet();
                    if (doipClient != null) doipClient.close();
                }
            });
        }
        int circle = 0;
        for (; total.get() < totalCount; ) {
            if (++circle % 100 == 0) {
                try {
                    Thread.sleep(10);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
            }
        }
    }
}
